【算法专题突破】双指针 - 有效三角形的个数(5)

目录

[1. 题目解析](#1. 题目解析)

[2. 算法原理](#2. 算法原理)

[3. 代码编写](#3. 代码编写)

写在最后:


1. 题目解析

题目链接:611. 有效三角形的个数 - 力扣(Leetcode)

我们可以根据示例1来理解这一道题目,

他说数组里面的数可以组成三角形三条边的个数,

那我们先自己枚举一下所有情况看看:

【2, 2, 3】

【2, 2, 4】

【2, 3, 4】

【2, 3, 4】

总共是四种情况,

而第二种情况是不成立的,看看示例,我们可以知道,虽然都是2,

但是不同位置可以看成不同的元素。

2. 算法原理

一开始我们看到这样的题目,实际上第一个想到的解法就是暴力枚举,

把所有情况枚举一遍然后判断,但是这是一个O(N3)的解法,

我们可以通过单调性和双指针的方式来优化我们的时间复杂度,

具体思路如下:

  1. 通过sort 找到最大值

  2. 使用双指针快速求出符合题目要求的数

具体操作如下:

以这个排好序的数组为例:

左指针指向最小的元素,右指针指向最大元素的左边元素,

跟据三角形两边之和需要大于第三边的性质,

如果 2 + 9 > 10,就证明 3 + 9,4 + 9 等等情况都会大于10,

这样我们就直接计算出 right - left 种适合的情况,

这样就能让所有的数都跟 9 结合过了,就让 right--。

如果 2 + 5 <= 10,就证明无论是 2 + 4 还是 2 + 3 等等情况,都会<=10,

所以我们就能直接让 left++,去找更大的数。

最后等left 和 right 相撞,就能求出所有适合的情况了。

3. 代码编写

cpp 复制代码
class Solution {
public:
    int triangleNumber(vector<int>& nums) {
        int ans = 0;
        sort(nums.begin(), nums.end());
        for(int i = nums.size() - 1; i > 1; i--) {
            int left = 0, right = i - 1;
            while(left < right) {
                if(nums[left] + nums[right] > nums[i]) {
                    ans += (right - left);
                    right--;
                }
                else left++;
            }
        }
        return ans;
    }
};

写在最后:

以上就是本篇文章的内容了,感谢你的阅读。

如果感到有所收获的话可以给博主点一个赞哦。

如果文章内容有遗漏或者错误的地方欢迎私信博主或者在评论区指出~

相关推荐
lzhdim3 小时前
AI的分类
人工智能·算法·机器学习·分类·数据挖掘
凤凰院凶涛QAQ6 小时前
《Java版数据结构 & 集合类剖析》Map & Set & 反射:“从哈希碰撞到红黑树转换,反射帮你扒开 HashMap 的桶数组看个究竟”
java·数据结构·算法
w_zero_one8 小时前
算法--模拟
java·数据结构·算法
秋天的怀念_David8 小时前
算法一千零一夜 · 第十三夜 幻方,武侠世界里的数学迷宫
java·程序人生·算法
·present·9 小时前
CSAPP(lecture 4_01)
c语言·c++
FPGA小迷弟9 小时前
用 Claude Code 重构遗留系统:从评估到落地的完整实践指南
c++·python·ai·plotly·django·ai编程·claude
秋天的怀念_David9 小时前
算法一千零一夜 · 第十四夜 幻方与奇妙的二进制
java·程序人生·算法
薛定e的猫咪9 小时前
(ICLR 2020)MAML 靠的不是快速学习,而是特征复用
人工智能·深度学习·学习·算法·机器学习
程序员-King.9 小时前
【ROS1】Noetic 开发工作流程与常用命令
c++·ubuntu·ros
云深麋鹿9 小时前
C++ | 基于红黑树实现mymap与myset
开发语言·c++